$(function() {
	var modal;
	var span;
	var action;
	function sendData(url, formData, _callback) {
		$.ajax({
			dataType: "json",
			type: "post",
			url: url,
			data: formData,
			cache: false,
			contentType: false,
			processData: false,
			success: function (data) {
				_callback(data);
			},
			error: function (data) {
				console.log(data);
			},
		});
	};
	var imageHandler = function() {
		modal = document.getElementById("images-modal");
		span = document.getElementsByClassName("modal-close")[0];
		action = document.getElementById("page-form").getAttribute("action");
		modal.style.display = "block";
		span.onclick = function() { modal.style.display = "none"; }

		modal.style.display = "block";
		span.onclick = function() { modal.style.display = "none"; }
		var formData = new FormData();
		formData.append("action", "image-selector");
		formData.append("timestamp_images", 
			document.getElementsByName("timestamp_images")[0].value
		);

		sendData(action, formData, function(result) {
			if(result.rows) {document.getElementById("modal-image-selector").innerHTML = result.rows}
		});
	};
	$("#modal-image-selector").on("click", ".image-select", function(e) {
		e.preventDefault();
		const link = $(this).attr("href");
		const range = quill.getSelection(true);
		quill.insertEmbed(range.index, 'image', link);
		quill.setSelection(range.index + 1, Quill.sources.SILENT);
		modal.style.display = "none";
	});
	
	// 'error', 'warn', 'log', or 'info'
	Quill.debug('error');

	var Inline = Quill.import('blots/block');
	class fleft extends Inline {    
		static create(value){
			let node = super.create();
			node.setAttribute('class','ql-float-left');
			return node;    
		}   
	}
	fleft.blotName = 'fleft';
	fleft.tagName = 'div';
	Quill.register(fleft);

	var Link = Quill.import('formats/link');
	class deflink extends Link {
		static create(value) {
			var node = Link.create(value);
			value = Link.sanitize(value);
			node.setAttribute('href', value);
			value.startsWith("https://example.com");
			node.removeAttribute('target');
			return node;
		}
	}
	Quill.register(deflink);

	hljs.configure({ // optionally configure hljs
		languages: ['javascript', 'html', 'php']
	});
	// <!--
	var quill = new Quill("#quill-editor", {
		theme: "snow",
		modules: {
			syntax: true,
			// Include button in toolbar
			toolbar: [
				[{'header': [1, 2, 3, 4, false]}], 
				['bold', 'italic', 'underline'],  
				[{'list': 'ordered'}, {'list': 'bullet'}],
				[{'align': []}],
				['link', 'image'],
				['code-block'],
				['clean'],
				['fleft']
			],
		},
	});
	var toolbar = quill.getModule('toolbar');
	toolbar.addHandler('image', imageHandler);
	// -->

	quill.on('text-change', async function(delta, oldDelta, source) {
		document.getElementById("quill-content").value = quill.root.innerHTML;
	});

	// remove 'render' button
	document.getElementById("render").remove();
});